Package org.codehaus.groovy.classgen

# Class ClassCompletionVerifier

java.lang.Object
org.codehaus.groovy.ast.CodeVisitorSupport
org.codehaus.groovy.ast.ClassCodeVisitorSupport
org.codehaus.groovy.classgen.ClassCompletionVerifier

All Implemented Interfaces:
  `GroovyClassVisitor`, `GroovyCodeVisitor`

public class ClassCompletionVerifier extends ClassCodeVisitorSupport
Checks that a class satisfies various conditions including:

- Incorrect class or method access modifiers
- No abstract methods appear in a non-abstract class
- Existence and correct visibility for inherited members
- Invalid attempts to override final members

## Constructor Summary

Constructors
Constructor
Description
`ClassCompletionVerifier(SourceUnit source)`

## Method Summary

Modifier and Type
Method
Description
`ClassNode`
`getClassNode()`
`protected SourceUnit`
`getSourceUnit()`
`void`
`visitBinaryExpression(BinaryExpression expression)`
`void`
`visitCatchStatement(CatchStatement cs)`
`void`
`visitClass(ClassNode node)`
Visit a ClassNode.
`void`
`visitConstantExpression(ConstantExpression expression)`
`void`
`visitConstructor(ConstructorNode node)`
Visit a ConstructorNode.
`void`
`visitDeclarationExpression(DeclarationExpression expression)`
`void`
`visitField(FieldNode node)`
Visit a FieldNode.
`void`
`visitGStringExpression(GStringExpression expression)`
`void`
`visitMethod(MethodNode node)`
Visit a MethodNode.
`void`
`visitMethodCallExpression(MethodCallExpression mce)`
`void`
`visitProperty(PropertyNode node)`
Visit a PropertyNode.

### Methods inherited from class org.codehaus.groovy.ast.ClassCodeVisitorSupport

`addError, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitClassCodeContainer, visitConstructorOrMethod, visitContinueStatement, visitDoWhileLoop, visitExpressionStatement, visitForLoop, visitIfElse, visitImports, visitObjectInitializerStatements, visitPackage, visitReturnStatement, visitStatement, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop`

### Methods inherited from class org.codehaus.groovy.ast.CodeVisitorSupport

`visitArgumentlistExpression, visitArrayExpression, visitAttributeExpression, visitBitwiseNegationExpression, visitBooleanExpression, visitBytecodeExpression, visitCastExpression, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstructorCallExpression, visitEmptyStatement, visitFieldExpression, visitListExpression, visitListOfExpressions, visitMapEntryExpression, visitMapExpression, visitMethodPointerExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitTernaryExpression, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ClassCompletionVerifier

public ClassCompletionVerifier(SourceUnit source)

## Method Details

### getClassNode

public ClassNode getClassNode()

### visitClass

public void visitClass(ClassNode node)
Description copied from interface: `GroovyClassVisitor`
Visit a ClassNode.

Specified by:
  `visitClass` in interface `GroovyClassVisitor`
Overrides:
  `visitClass` in class `ClassCodeVisitorSupport`

### getSourceUnit

protected SourceUnit getSourceUnit()

Specified by:
  `getSourceUnit` in class `ClassCodeVisitorSupport`

### visitMethod

public void visitMethod(MethodNode node)
Description copied from interface: `GroovyClassVisitor`
Visit a MethodNode.

Specified by:
  `visitMethod` in interface `GroovyClassVisitor`
Overrides:
  `visitMethod` in class `ClassCodeVisitorSupport`

### visitField

public void visitField(FieldNode node)
Description copied from interface: `GroovyClassVisitor`
Visit a FieldNode.

Specified by:
  `visitField` in interface `GroovyClassVisitor`
Overrides:
  `visitField` in class `ClassCodeVisitorSupport`

### visitProperty

public void visitProperty(PropertyNode node)
Description copied from interface: `GroovyClassVisitor`
Visit a PropertyNode.

Specified by:
  `visitProperty` in interface `GroovyClassVisitor`
Overrides:
  `visitProperty` in class `ClassCodeVisitorSupport`

### visitBinaryExpression

public void visitBinaryExpression(BinaryExpression expression)

Specified by:
  `visitBinaryExpression` in interface `GroovyCodeVisitor`
Overrides:
  `visitBinaryExpression` in class `CodeVisitorSupport`

### visitConstructor

public void visitConstructor(ConstructorNode node)
Description copied from interface: `GroovyClassVisitor`
Visit a ConstructorNode.

Specified by:
  `visitConstructor` in interface `GroovyClassVisitor`
Overrides:
  `visitConstructor` in class `ClassCodeVisitorSupport`

### visitCatchStatement

public void visitCatchStatement(CatchStatement cs)

Specified by:
  `visitCatchStatement` in interface `GroovyCodeVisitor`
Overrides:
  `visitCatchStatement` in class `ClassCodeVisitorSupport`

### visitMethodCallExpression

public void visitMethodCallExpression(MethodCallExpression mce)

Specified by:
  `visitMethodCallExpression` in interface `GroovyCodeVisitor`
Overrides:
  `visitMethodCallExpression` in class `CodeVisitorSupport`

### visitDeclarationExpression

public void visitDeclarationExpression(DeclarationExpression expression)

Specified by:
  `visitDeclarationExpression` in interface `GroovyCodeVisitor`
Overrides:
  `visitDeclarationExpression` in class `ClassCodeVisitorSupport`

### visitConstantExpression

public void visitConstantExpression(ConstantExpression expression)

Specified by:
  `visitConstantExpression` in interface `GroovyCodeVisitor`
Overrides:
  `visitConstantExpression` in class `CodeVisitorSupport`

### visitGStringExpression

public void visitGStringExpression(GStringExpression expression)

Specified by:
  `visitGStringExpression` in interface `GroovyCodeVisitor`
Overrides:
  `visitGStringExpression` in class `CodeVisitorSupport`